Introduction

CDex is a is utility which can extract Digital Audio (DA) tracks  from CD into the files. The recorded audio tracks can be stored as either WAV files, as MP3 (MPEG-1 Audio Layer-3, several encoders are supported), VQF files or AAC files (if you have the proper encoders). CDex is using the Adaptec’s ASPI library Manager to communicate with the CD-ROM device, make sure that you have installed a proper ASPI manager (like Adaptec ASPI manager version 4.54 or 4.57).

You might visit the home page of CDex  (http://www.surf.to/cdex) to see whether you have the latest version.

I know, this help file is not still what it should be, but it takes a lot of time to document and keep it up to date with the latest features and problems that people are reporting.

What’s New in version 1.10:

Re- engineered the entire encoder

Added the ripping stuff in a separate DLL

Added the CD selection bar in the main menu

Better support for external encoders

Dropped (or convert WAV files) now also supports

Multiple CD-ROM configurations are supported (i.e. the settings of each CD-ROM are saved in the INI file)

Added support to get the CDDB server list

More flexible file name building

Support for Windows MP3 compression codecs

What’s New in version 1.0:

Added support for external encoders (AAC/VQF/MP3 like Blade Encoder, Plugger, L3Enc etc.)

Added support for Blade Encoder DLL

Remote CDDB support

Several bug fixes

Improved user interface

Status of software:

CDex is FREEWARE and I like to keep it that way. Although support (esp. on-line time) and development tools are quite expensive, therefore you can support CDex by sending a small donation.

For more information, see Cdex home page ( http://www.surf.to/cdex)

Author of CDex:

CDex is solely developed by Albert L Faber.

Quick Tour:

Start Cdex, make sure when you create a short cut, that the working directory is pointing to the CDex directory. To use CDex, I would suggest to first configure CDex. First select the configure button (F4) and select a proper output directory.

Secondly, select the CD-ROM tab and make sure that the CD-ROM settings are correct. At least make sure that the logical drive letter is setup correctly for your CD-ROM (otherwise you might get problems with reading the CDPlayer.ini file.

Optionally you might select another encoder. You can select the encoder by clicking on the MP3 tab.

Finally, you have to fill out the CDDB settings (at least make sure that you specify your e-mail address when you want to use the remote CDDB functionality.

Once you have setup everything, click on the OK button. The setting will be stored to the CDex.ini  file that is located in the windows directory.

Now the setup has been completed, it is time to Rip some files:

Select one (or more) tracks from the track list (use ctrl left mouse click or shift left mouse click to select multiple files). The selected tracks can be ripped to either WAV (F8) files or encoded file, like MP3 (F9). Instead of the function keys, you can also select the first or second button respectively at the Record short-cut bar located at the right side of your screen.

CDex also support local and remote CDDB, all you have to do is to enter an e-mail (or at least something that looks like an e-mail address, like john@do.com address in the CDDB configuration tab.

To rename the track files, you have to select a track first, once the track is selected, click on it again  (with left mouse button, or press the F2 key), now a cursor will appear, type in the track. Hit the return key when done (this procedure is similar to the file renaming the Windows Explorer). Or, if you have selected a track,  you can use the right mouse button to get the pop-up menu, select rename and the text cursor will appear.


System requirements

1.	Microsoft Windows 95/98/NT

2.	Adaptec’s ASPI for Win32 Manager

3.	A CD-ROM which has Digital Audio Extracting capabilities (most IDE drives and SCSI drives will do)

4.	Intel  Pentium or compatible processor

5.	Lot’s of free disk space to record your WAV files

6.	A player is recommended (utilities like WinAmp or MaPlay are good free/shareware utilities. Take a look at www.mp3.com where you can find a much more information about MP3.


Installation

CDex is shipped as a plain zip file. CDex can be installed by extracting all the files from the zip file to a directory you want to install CDex, afterwards just launch the CDex.exe file to start CDex

How To Uninstall CDex:

Just remove the directory where CDex is stored, and remove the CDex.ini file from the windows directory.

How to Configure CDex

You can configure CDex by clicking on the configure button in the main dialog box. Important items to set are:

•	Which CD-ROM to use (if you have more than 1 CD-ROM drive) and which logical drive letter is associated with it

•	Furthermore I recommend to change the output directory where the WAV files of the recorded tracks will be stored.

For more details about the other settings, please look at the configure section of the help file.


Bugs, comments & suggestions

IMPORTANT:

Do not send me large attachments of large files! If you have a problem, please READ the help file first, if this doesn’t solve your problems, take a look at the latest FAQ on my website (www.surf.to/cdex), it maybe will address your problem(s). If you still have problems, well then you can send me an e-mail with your specific problems. Also include as much as possible information about your system. Like

Which version of CDex do you use

What ASPI drivers do you use?

What kind of CD-ROM do you have (brand + type)

What kind of CD-ROM settings do you use (Read Sectors & Read Overlap)

Did you try the Auto Detect function yet

Which encoder you have selected

Furthermore, add the information which is displayed in the System Info dialog box. For your convenience, you can let CDex copy the information into the clipboard, which you can paste (Control V) in you e-mail program.

For more information, please take a look at the official CDex site located at http://www.surf.to/cdex


Warranty

THIS APPLICATION AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

ALFA TECHNOLOGIES DOES NOT REPRESENT OR WARRANT THAT THE PROGRAMS OR PROGRAM COMPONENTS ARE FREE OF INFRINGEMENT OR ANY THIRD-PARTY PATENTS, COPYRIGHTS OR TRADE SECRETS.


Acknowledgment

Credit’s are where credits due, here they are:

First of all I like to thank Karsten Madsen and José de Leon for extensively testing CDex ( I think they have gone trough all beta releases) and for their useful suggestions. Without them, CDex did certainly lack many features and definitely would not be as stable as it is today, thanks guys!

CDDB is designed and developed by Ti Kan and Steve Scherf, thanks for making such an useful product.

Blade Encoder is developed and maintained by Tord Jansson  (home page: Error! Reference source not found.)


Configure

The configure dialog box has 4 tabs, select the links below to get more specific information on the topics

•	General Settings

•	CD-ROM Settings

•	MP3 Settings

•	CDDB Settings


CDex Help Index

Test Dialog


What is CD-DA

The process of direct reading the audio data is called CD Digital Audio (CD-DA) or sometimes referred to as ‘Digital Audio Extraction’ (DAE) or as ‘CD ripping’. CDex uses CD-DA to read the audio data of the CD disc and write the resulting data into a WAV file or a MP3 file. The advantage of CD-DA above recording the file using your sound card is that there is no loss of music quality, the data in the WAV file are an exact copy of the data on the disc. For the insiders, using your sound card, the digital data from the disc is converted to an analog signal, which is digitized again by the sound card. Often the sound quality will be deteriorated when going this route, especially noisy WAV are not uncommon.


FAQ (Frequently Asked Questions)

PLEASE, DO NOT SEND ME MP3 FILES OR WAV FILES, UNLESS I SPECIFICLY ASK FOR IT !!!!!

Q: When I extract files, there are is no music information, just dead silence

It can be either two things, or your drive doesn't support CD-DA (see next question). If your drive supports CD-DA, you can try the following option (CDex version 0.15b7 and up)

IMPORTANT:

It seems like that some drives produce an empty file when the Read Sectors exceed 27sectors, so you might want to try to lower this value to 27 (or even 26)! (Please drop me an e-mail if this is the case with your CD-ROM, so I can add exceptions to the software) If this still does not work, try to use the auto detect feature as described below.

Go to the configure menu (press the configure menu in the main CDex screen)

Select the CD-ROM Tab.

Press the auto detect function. In order to perform auto detection, you have to have an Audio CD-ROM in your CD-ROM drive. The auto detection might take some time ( a couple of minutes ). If your lucky, the auto detection find at least one combination that reports success. Select this line from the list box and press the OK button. If it does not work, send me the file CDexAutoDetect.txt which should be created in the root directory of your drive.

Note: Some people have reported that CDex or the system would crash when doing the auto detection procedure, they got around this problem by turning of the DMA setting in the

Control Panel-> System -> Device Manager ->CD-ROM -> Your CD-ROM (press properties button and select the Settings TAB). Of course, don't take Your CD-ROM literal, it means the brand/type of the CD-ROM which you want to perform the auto detect procedure.

If CDex is not still able to read audio data from your CD-ROM, please send me an e-mail, include the CDexAutoDetect.txt and add also the info you get from the System Info button (see also contact for more details what information is useful for me).

Q: Does my drive supports CD-DA

There is a list available at http://www.mp3.com/cdrom.html, see if you're drive is on this list and whether it support digital audio extraction.

Q: When I convert/rip MP3 files, CDex is slow as molasses, what wrong with my system?

A: Well nothing I would say. The MP3 compression consumes a lot of computation time, actually, CDex is relatively fast compared to other MP3 encoders (with comparable sound quality, listen the output of the Xing 'fast' encoder, and you know what I mean). Version 0.15b2 and up, contains a more optimized encoder, you might give it a try. To give you a measure of CDex version 0.15b2:

Pentium 166-MMX, with 32 Mb of SD-RAM, a one minute song, takes about 3 minutes.

Q: The program crashes during start-up or when there is no CD in the CD-ROM.

A: I know this is a bug in earlier versions, this should be fixed in the from version 0.14b4 and up. Furthermore, there seem to be a problem with the Install Shield setup, CDex crashes the first time it is executed, at this moment I don't know exactly what the problem is, therefore the latest versions of CDex are distributed as a zip file again ( look at the bright side, the zip file is much smaller too, install shield adds an incredible overhead to the install file ~4 times the size of CDex )

Q: I get an message that there is too much jitter, what do I have to do to solve this problem?

Well, you can try to increase the Read Overlap value in the configuration dialog box (i.e. press configure from the main dialog box). Make sure that the CD is clean, dirty discs can cause jitter problems. Furthermore I have also a disc (Guns 'n' Roses, use your illusion part II) which also gives me a bunch of errors. So you may want to try another disc first. Furthermore, the overlap and block compare value are restricted, make sure that the sum of the two do not exceed 27 (I was too skimpy, by using a 16 bit integer instead of 32 bit integer, sound like the millennium problem). This will bet fixed in the from version 0.15b3 and up.

See the CD-ROM configure for more details

Q: Where can I download the ASPI drivers

Go to the CDex web site, here you find more information (under useful links) where to download the proper ASPI drivers.


Auto Detect dialog box

The auto detect function can be used perform an auto detection of the all possible CD-ROM audio read settings. It is important that you have to have an Audio CD-ROM in your CD-ROM drive. The auto detection might take some time ( a couple of minutes ). If your lucky, the auto detection find at least one combination that reports success. Select this line from the list box and press the OK button. If it does not work, send me the file CDexAutoDetect.txt which should be created in the root directory of your drive.

Note: Some people have reported that CDex or the system would crash when doing the auto detection procedure, they got around this problem by turning of the DMA setting in the

Control Panel-> System -> Device Manager ->CD-ROM -> Your CD-ROM (press properties button and select the Settings TAB). Of course, don't take Your CD-ROM literal, it means the brand/type of the CD-ROM which you want to perform the auto detect procedure.

If CDex is not still able to read audio data from your CD-ROM, please send me an e-mail, include the CDexAutoDetect.txt and add also the info you get from the System Info button (see also contact for more details what information is useful for me).


Main Screen

The main screen shows the track information, and has by default two toolbars. The list view shows the content of the CD-ROM, you can select one or more tracks by clicking in the tracks you want to extract from the CD. If you want select multiple tracks, hold down the Control or Shift key while selecting the tracks. The track information can be renamed, by clicking on the selected track again (or use the F2 short cut key).

Besides the track list and album information, the main screen has by default two toolbars, the play toolbar and the record toolbar. The toolbars can be made floating and can be docked anywhere in the main screen, so you can customize the lay out.

For more help topics, please select the content button and click on the CDex entry  button to get a table of contents. Select topic to get the desired help information.


General Settings

File name builder:

File naming has been changed since version 1.10.

The file name option string determines how the output files will be saved to disk. The following identifiers are available to create dynamic file names:

%1	Artist information

%2	Album information

%3	Track number

%4	Track name

%5	CD Volume ID

%6	CDDB ID

Also the backslash (\) might be used to indicate what part will be used as a directory name. Beware that your should not start nor end with the backslash in the file name option dialog. Neither you have to specify the extension of the file

Example:

%1\%2\%4	create the file Track name in the directory artist\album

%1-%2-%3	creates the file track artist-album-track name

Add Files to M3U Playlist.

When enabled, it will add the recorded files to the file Playlist.m3U, which is locate in the Recorded Tracks output directory.

Add Files to PLS Playlist.

When enabled, it will add the recorded files to the file Playlist.pls, which is locate in the Recorded Tracks output directory.

Normalize track volume:

Often CDs are recorded with different volume levels. CDex has an option to normalize the volume levels if the volume level of the record track is out of bounce. The upper and lower boundary as well as the normalization values can be specified in the three edit boxes. The values are in percentages. Keep in mind that this option only works when you the On The Fly MP3 encoding is disabled.

Default setting:	Normalization value	98%

Lower  value	91%

Upper value	99 %

WAV->MP3 Output Directory:

This indicates where the converted MP3 files should be stored. The output directory can be changed by pressing on the .. button. Once selected, as directory selection dialog should pop up, select the appropriate output directory and press the OK button..

Recorded Tracks Output Directory:

This indicates where the recorded MP3 (or WAV files) are stored after ripping. The output directory can be changed by pressing on the .. button. Once selected, as directory selection dialog should pop up, select the appropriate output directory and press the OK button..


CD-ROM Settings

CD-ROM drop down list:

This selection box shows the available CD-ROMs, select the CD-ROM from which you want to record the tracks .

Logical drive:

You have to select which  logical drive letter is associated with the selected CD-ROM device.

Read Sector (default value 26)

IMPORTANT:

The meaning of this value has been changed since version 1.10. In version 1.0 CDex did read Read Sector+Read overlap sectors (this was confusing to some people, so I changed in version 1.10

Some drive can’t read more than 26 sectors at once, thus if you get silent WAV files, make sure that this value is less than 27.

Read Overlap (default value 7):

The problem with reading the audio CD format is that you can’t very well position the starting track. This might cause a miss alignment when reading two separate blocks of data (thus either gaps can occur, where some sound data is getting lost, or there might be overlap between first and second block of data). To solve this problem, CDex uses a so called jitter correction, which means CDex is not position the laser to the end of the first block, but a few sectors earlier. This number of overlapping sectors can be entered in the Read Overlap field, this number should be large enough so there will be enough overlap compensate the miss positioning of the laser. If you hear strange noises in your MP3 or WAV file, try to increase this number (but should of course be less than the Read Sector value.

Block Compare (default value 1):

Now we have read some additional sectors, it is time to actually do the jitter correction. Therefore, the last sectors of the first data block is compared with the sectors of the second data block. Of course, the question is how many sectors do we have to compare to be sure that the blocks are really aligned. Well, I am using 1, but if you think this is not enough, please feel free to increase this number (which of course will slow down the recording process and might increase the number of jitter errors). Make sure though that the Block Compare  value does not exceed 0.5* Read Overlap.

CD Speed (default value 0):

Indicates the relative reading speed of the CD-ROM. The default value is 0, which means that is uses the default recording speed.  You might want to try to increase this value (e.g. 16) in order to speed up the ripping process (mostly noticeable when ripping WAV files)

CD-Read Type (default value Generic):

This option allows you to select the CD-ROM brand you have, based in this information CD audio data is read differently. By default it is set to Generic, which should work for most drives. However, if you don’t get any audio data into the WAV or MP3 file, you might want to change this setting to your specific brand of CD-ROM.

Auto Detect Button:

Press the auto detect function. In order to perform auto detection, you have to have an Audio CD-ROM in your CD-ROM drive. The auto detection might take some time ( a couple of minutes ). If your lucky, the auto detection find at least one combination that reports success. Select this line from the list box and press the OK button. If it does not work, send me the file CDexAutoDetect.txt which should be created in the root directory of your drive.

Note: Some people have reported that CDex or the system would crash when doing the auto detection procedure, they got around this problem by turning of the DMA setting in the

Control Panel-> System -> Device Manager ->CD-ROM -> Your CD-ROM (press properties button and select the Settings TAB). Of course, don't take Your CD-ROM literal, it means the brand/type of the CD-ROM which you want to perform the auto detect procedure.

If CDex is not still able to read audio data from your CD-ROM, please send me an e-mail, include the CDexAutoDetect.txt and add also the info you get from the System Info button (see also contact for more details what information is useful for me).

Swap Left Right Channel (default value off):

With certain types of  CD-ROMs, the left and right channel are alternated. With this option enabled, you can correct for it.

Enable Jitter correction (default value on):

This setting determines if the jitter correction should be enabled or not. Unless you have a very good CD-ROM, I would advice you to turn on the jitter correction, to avoid click/plops and other artifacts in the extracted WAV of MP3 file.

Start and end Offset (default values 0):

With the start and end offset you can tweak the actual start and end position. The values can be positive as well as negative. One unit correspond to a sector, which is 1/75th of a second.

Spin up time (default value 0):

Some drives give small artifacts in the first couple of seconds of the WAV file, this is likely that the CD-ROM has not spun up yet completely. In order to avoid these artifacts, you can increase this spin up time value (in seconds).


MP3 Settings

Encoder Type

The encoder type specifies which encoder is used. Depending on the selected encoder, you can fill out the proper options:

Add ID3 Tag:

CDex can write an ID3 Tag at the end of the MP3 file. This tag contains some information about the recorded track (this information can be displayed by the MP3 player, e.g. winamp)

Internal MP3, Internal MP2 and Blade DLL encoder options:

Bitrate (default value 128 kBits/s):

Determines the number of bits per second, higher bitrates result in better sound quality, but also increases the file size. You can calculate the output file size based on the bit rate as follows:

MP3FileSize [kBits/s] = Bitrate [kBits/s] * Song Duration [sec]

Thus a song with a play time of 3 minutes and 16 seconds will yield to:

MP3FileSize= 128.000 * (3*60 + 16) = 25088000 [kBits] = 3136000 [Bytes] = 3062.5 [KB]

If this song was recorded (44.1 Samples/sec/channel with 16 bits per sample) as a plain WAV file, the file size would be:

WAVFileSize= 44.100 * 2 * 2 * (3*60+16) = 33764.9 [KB]

Thus the compression ratio in this example is: 33764.9/3062.5 = 11 x

Channels (default value Stereo):

Currently only the stereo value is implemented

On the fly MP3 encoding (default  value on):

When enabled, tracks are recorded directly to MP3 files. However, in some configuration people have heard strange “click’s” in their MP3 files. Therefore this is kind of a kludge, it will first record the files to a WAV file, which will than after each recorded track be converted to a MP3 file, the WAV file is deleted afterwards.  DISABLE THIS OPTION IF YOU EXPERIENCE STRANGE CLICK’S IN YOUR MP3 FILES.

External MP3 encoder options.

In order to use a DOS based external encoder, you have first to pick the exe file or bat file in case of the homeboy AAC encoder, just select the browse button, and a file open dialog box will appear, go to the appropriate directory and select the exe or bat file.

Once you have selected the file, you have to select if this is an MP3 or AAC encoder (vqf is grayed at the moment, since I have not a dos based VQF encoder).

AAC Astrid/Quartex encoder:

To setup the encoder, press the browse button, no navigate to the proper directory where you have installed the AAC encoder (filename: AacEnc.exe). For the AAC encoder, only the Bitrate can be selected (see Internal MP3 encoder options for more details) . Keep in mind that only a few bitrates are supported (see AAC encoder documentation for more details)

Yamaha VQF encoder options

In order to use the VQF encoder, select the browse button in the MP3 settings dialog, a file selection dialog box should appear, Locate the file SVQbatch.exe (default installed in the \program files\yamaha\ SoundVQenc directory). Click on the OK button and select the VQF radio button and you are all set.

Windows Codec options

There are two drop down lists. The first one specifies which encoder to use. The second one specifies what mode should be used for encoding.

On the fly MP3 encoding (default  value on)

See internal MP3 options for more details


System Information

The System Information dialog box displays information that is important when you submit a bug report. For your convenience, you can let CDex copy the information to the clipboard which you can paste (Control V) in you e-mail program.


CDDB Settings

Remote server:

Select one of the remote server, probably the fastest response time will be obtained when you select a server that is physically located the closest to you.

E-mail address:

In order to access the CDDB remote data base, CDex has to provide an e-mail address. Therefore you have to enter an e-mail (or at least something that looks like an e-mail address in this field.

Local CDDB path:

CDex will store the data gathered from the remote server into a local CDDB data base. You have to provide the location where you want to store the files, or if you point it to an existing local CDDB.

CDDB type:

The local CDDB files can be stored in either Windows type CDDB or an UNIX type CDDB. The advantages of the UNIX CDDB is that for each entry a unique file is created. This allows much faster lookup of CDDB entries. However, due to the nature of a FAT16 partitions, each file can take a considerable amount of disk space. This can be avoided by using the Windows type of CDDB, which will store several entries into one file.

Store in CDPlayer.ini file:

You can store the results gathered from the remote CDDB (or If you entered them manually) in the CDPlayer.ini file as well. This allows you to use the CDDB information for the Windows CD player as well.

Store in local CDDB:

When enabled, CDex will store the track/album information gathered from the remote CDDB (or If you entered them manually) in the local CDDB data base. It is recommended that you have this option enabled, since the CDDB can hold much more information then the CDPlayer.ini file.


View Play Toolbar

This option allows you to control the visibility of the Play toolbar.


View Record Toolbar

This option allows you to control the visibility of the Record toolbar.


Tracks To Wav
Tracks To Wav file

This option allows you to extract the selected CD audio tracks into a WAV file.


Extract partial track

This option allows you to extract a section of CD into one WAV or MP3 file. This can be handy when you want to extract data from a live CD for example, or if you are only interested in one particular section of a CD track.


WAV to MP3

When selecting this option, a file dialog will appear. You can select multiple file, and convert them to MP3 files using the MP3 encoder. You can also drag and drop WAV files into CDex, this will convert the WAV files into MP3 files as well


MP3 to Riff-WAV

RIFF-WAV files are regular MP3 files with an additional WAV type header section. The advantage of RIFF-WAV MP3 files is that they can be played with the regular windows WAV player, if there is a windows MP3 codec installed.


Tracks to MP3 file

This option allows you to extract the selected CD audio tracks into a compressed MP3 file.


Application Exit

Selecting exit will close the CDex application


CDex Help

For more help topics, please select the content button and click on the CDex entry  button to get a table of contents. Select topic to get the desired help information.